﻿Public Class Form1

    ' start all tests
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click


        ' ===========================================
        ' test 01 :DBMS class open connection method
        ' ===========================================
        Dim OBJ As New LibraryManagementSystem.DBMSClass
        If OBJ.OpenDB = "OK" Then
            ListBox1.Items.Add("test 01 OK")
        Else
            ListBox2.Items.Add("test 01 failed")
        End If

        ' ==========================================
        ' test 02 :DBMS class execute sql
        ' ==========================================
        Try
            OBJ.ExecuteSQL("insert into vars values (@0,@1)", "hello1", "everyone1")
            OBJ.ExecuteSQL("insert into vars values (@0,@1)", "hello2", "everyone2")
            OBJ.ExecuteSQL("insert into vars values (@0,@1)", "hello3", "everyone3")
            ListBox1.Items.Add("test 02 OK")
        Catch ex As Exception
            ListBox2.Items.Add("test 02 failed")
        End Try

        ' =========================================
        ' test 03 : DBMS class read result set
        ' =========================================
        Try
            Dim L = OBJ.CreateResultSet("select * from vars")
            Do While OBJ.ReadAndNotEOF(L)
                Dim V = OBJ.GetColumnValue(L, "varname")
            Loop
            OBJ.CloseResultSet(L)
            ListBox1.Items.Add("test 03 OK")
        Catch ex As Exception
            ListBox2.Items.Add("test 03 failed")
        End Try

        ' =========================================
        ' test 04 : staff insert record
        ' =========================================
        Dim StaffObj As New LibraryManagementSystem.StaffClass
        StaffObj.SetEmployeeLoginName("smith")
        StaffObj.SetEmployeeName("john smith")
        StaffObj.SetEmployeePassword("123")

        If StaffObj.InsertIntoDB(OBJ, False) Then
            ListBox1.Items.Add("test 04 OK")
        Else
            ListBox2.Items.Add("test 04 failed")
        End If


        ' ==========================================
        ' test 05 : staff load record
        ' ==========================================
        Dim StaffObj2 As New LibraryManagementSystem.StaffClass
        If StaffObj2.LoadFromDB(OBJ, "smith") Then
            ListBox1.Items.Add("test 05 OK")
        Else
            ListBox2.Items.Add("test 05 failed")
        End If

        ' ==========================================
        ' test 06 : staff update
        ' ==========================================
        StaffObj2.SetEmployeeLoginName("smith2")
        If StaffObj2.UpdateDB(OBJ, False) Then
            ListBox1.Items.Add("test 06 OK")
        Else
            ListBox2.Items.Add("test 06 failed")
        End If

        ' ==========================================
        ' test 07 : staff remove
        ' ==========================================
        If StaffObj2.RemoveFromDB(OBJ, False) Then
            ListBox1.Items.Add("test 07 OK")
        Else
            ListBox2.Items.Add("test 07 failed")
        End If


        ' ==========================================
        ' test 08 : fill datagridview
        ' ==========================================
        Dim TMPDGV As New DataGridView
        If OBJ.FillDataGridViewWithData(TMPDGV, "select * from vars") Then
            ListBox1.Items.Add("test 08 OK")
        Else
            ListBox2.Items.Add("test 08 failed")
        End If

        ' ==========================================
        ' test 09 staff login
        ' ==========================================
        Dim TmpStaffObj As New LibraryManagementSystem.StaffClass
        TmpStaffObj.SetEmployeeLoginName("A")
        TmpStaffObj.SetEmployeeName("ABC")
        TmpStaffObj.SetEmployeePassword("B")
        TmpStaffObj.InsertIntoDB(OBJ, False)

        Dim TmpStaff = LibraryManagementSystem.StaffClass.Login(OBJ, "A", "B")
        If TmpStaff IsNot Nothing Then
            ListBox1.Items.Add("test 09 OK")
        Else
            ListBox2.Items.Add("test 09 failed")
        End If

        ' ==========================================
        ' test 10 insert new shelf
        ' ==========================================
        Dim SHF As New LibraryManagementSystem.ShelfClass
        SHF.SetShelfNo("abc")
        SHF.SetSection("A")
        SHF.SetFloor("3")
        If SHF.InsertIntoDB(OBJ, False) Then
            ListBox1.Items.Add("test 10 OK")
        Else
            ListBox2.Items.Add("test 10 failed")
        End If

        ' ==========================================
        ' test 11 load the shelf
        ' ==========================================
        Dim SHF2 As New LibraryManagementSystem.ShelfClass
        If SHF2.LoadFromDB(OBJ, "abc") Then
            ListBox1.Items.Add("test 11 OK")
        Else
            ListBox2.Items.Add("test 11 failed")
        End If

        ' ==========================================
        ' test 12 edit  the shelf
        ' ==========================================
        SHF2.SetFloor("vfneruinhuier")
        If SHF2.UpdateDB(OBJ, False) Then
            ListBox1.Items.Add("test 12 OK")
        Else
            ListBox2.Items.Add("test 12 failed")
        End If

        ' ==========================================
        ' test 13 remove the shelf
        ' ==========================================
        If SHF2.RemoveFromDB(OBJ, False) Then
            ListBox1.Items.Add("test 13 OK")
        Else
            ListBox2.Items.Add("test 13 failed")
        End If

        ' ==========================================
        ' test 14 add new book
        ' ==========================================
        Dim BK As New LibraryManagementSystem.BookClass
        BK.SetBookID(123)
        BK.SetBookTitle("introduction to vb programming")
        BK.SetBookAuthor("someone")
        BK.SetBarcode("3843826728")
        BK.SetBookPress("super kitty")
        BK.SetShelfNO("wxyz")
        BK.SetBookPublicationYear(1999)
        BK.SetBookSubject("programming")
        BK.SetBookKeywords("programming tutorial how to")
        BK.SetAvailableCopies(9)
        BK.SetTotalCopies(9)


        Dim SHF3 As New LibraryManagementSystem.ShelfClass
        SHF3.SetShelfNo("wxyz")
        SHF3.SetSection("programming")
        SHF3.SetFloor("1")
        If Not SHF3.InsertIntoDB(OBJ, False) Then
            ListBox2.Items.Add("test 14 failed")
        End If

        If BK.InsertIntoDB(OBJ, False) Then
            ListBox1.Items.Add("test 14 OK")
        Else
            ListBox2.Items.Add("test 14 failed")
        End If

        ' ==========================================
        ' test 15 load book
        ' ==========================================
        Dim BK2 As New LibraryManagementSystem.BookClass
        If BK2.LoadFromDB(OBJ, BK.GetBookID) Then
            ListBox1.Items.Add("test 15 OK")
        Else
            ListBox2.Items.Add("test 15 failed")
        End If


        ' ==========================================
        ' test 16 modify or edit book
        ' ==========================================
        BK2.SetAvailableCopies(22)
        BK2.SetBookTitle("the amazing cat")
        If BK2.UpdateDB(OBJ, False) Then
            ListBox1.Items.Add("test 16 OK")
        Else
            ListBox2.Items.Add("test 16 failed")
        End If

        ' ==========================================
        ' test 17 remove book
        ' ==========================================
        If BK2.RemoveFromDB(OBJ, False) Then
            ListBox1.Items.Add("test 17 OK")
        Else
            ListBox2.Items.Add("test 17 failed")
        End If

        ' ==========================================
        ' test 18 insert new student
        ' ==========================================
        Dim ST As New LibraryManagementSystem.StudentClass
        ST.SetStudentName("todd")
        ST.SetStudentContact("7483979")
        ST.SetStudentEmail("todd@yahoo.com")
        ST.SetStudentIDENT("988928282")
        ST.SetStudentYear("2011")
        ST.SetStudentPassword("")
        ST.SetStudentLoginName("todd")

        If ST.InsertIntoDB(OBJ, False) Then
            ListBox1.Items.Add("test 18 OK")
        Else
            ListBox2.Items.Add("test 18 failed")
        End If

        ' ==========================================
        ' test 19 load student
        ' ==========================================
        Dim ST2 As New LibraryManagementSystem.StudentClass
        
        If ST2.LoadFromDBByID(OBJ, ST.GetStudentID) Then
            ListBox1.Items.Add("test 19 OK")
        Else
            ListBox2.Items.Add("test 19 failed")
        End If

        ' ==========================================
        ' test 19.5 load student
        ' ==========================================
        Dim ST3 As New LibraryManagementSystem.StudentClass

        If ST2.LoadFromDBByLoginName(OBJ, ST.GetStudentLoginName) Then
            ListBox1.Items.Add("test 19.5 OK")
        Else
            ListBox2.Items.Add("test 19.5 failed")
        End If


        ' ==========================================
        ' test 20 modify the infro
        ' ==========================================
        ST2.SetStudentName("meyao")
        If ST2.UpdateDB(OBJ, False) Then
            ListBox1.Items.Add("test 20 OK")
        Else
            ListBox2.Items.Add("test 20 failed")
        End If

        ' ==========================================
        ' test 21 remove student info
        ' ==========================================
        If ST2.RemoveFromDB(OBJ, False) Then
            ListBox1.Items.Add("test 21 OK")
        Else
            ListBox2.Items.Add("test 21 failed")
        End If

        OBJ.Rollback()

    End Sub
End Class
